#ifndef  SPHRSPWA_H
#define  SPHRSPWA_H

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <mem.h>
#include <stdlib.h>
#include <math.h>
#include <values.h>
#include <time.h>
#include <process.h>
#define X_OFFS  160.0
#define Y_OFFS  100.0
#define X_RES   320
#define Y_RES   200
#define X_RESM  319
#define Y_RESM  199
#define VIDEO 0xA000
#define PUTPIXS(x,y,color) canvas[x+((y)<<8)+((y)<<6)] = color
#define GETPIXS(x,y) canvas[x+((y)<<8)+((y)<<6)]
#define M_PIO2 1.57079632679489661923
#define M_PIT2 6.28318530717958647692
#define MAX_SHOTS 6
#define SHOTDRAWMEM 5
#define SHOTEXPLVEL 0.05 // in old pixel units, multiply by M_PI/Y_RES for sphere central angle units
#define BACKPROJDIFF 4
#define PROJECTIONS 10
#define TRAJMATHS 3
#define OBJDRAWS 3
#define ERASES 4
#define AVDE 0.01 // fractional change of angular velocity threshold for deactivating player turn command, to let the av change from a collision show 
#define LOOPSPTICK 18.0 // central pick of loops per clock tick for option to scale moves speeds by LOOPSPTICK/prevloopcts
#define GRAV   3.50e-8 //some gravitational constant
#define CL     0.01458312395177699925 //some wavespeed
#define BLACKABPIXGRABS 25

extern unsigned char far *SCREEN;
extern unsigned char far *canvas;

typedef void (*projecpointer)(float , float , int *, int *) ;
extern projecpointer projec;

extern projecpointer mixprojold, mixprojnew;
extern float mixproja; // and (1-mixproja), coefficients for linear combination of projections

extern void (*drawobj)(float, float, float, float, int, int);

extern void (*p1p2bounces)(float);

extern void (*playerwallbounces)(float , float , float *, float *, float *);

extern float (*metric)(float , float , float, float) ;

extern void (*surfacerun)(float , float , float , float , float *, float *) ;

extern void (*intermediatepoint)(float , float , float , float , float , float *, float *) ;

extern float (*angtofrom)(float , float , float , float ) ;

extern void (*moveplayer)(float *, float *, float , float *, float *, float , float) ;

extern float (*playermoment)(float) ;

extern void (*absorbknockturn)(float *, float , float , float , float , float , float) ;

// player control increments
extern float vinc; //speed increment
extern float ainc; // turning angle increment 2pi/44; 

// player 1
extern int   p1exists;
extern float p1lat, p1long;  // int p1[2]; // lat,long ; screen x,y
extern float p1a; // angle that player is facing
extern float p1at;  // angle of travel, angles are north of east;
extern float p1v; // speed
extern float p1av; // angular velocity
extern float p1rad; // player 1 saucer radius
extern int p1colc, p1colf; //color of center, color of forward angle
extern unsigned int p1shotsfired;

// player 2
extern int   p2exists;
extern float p2lat, p2long; //int p2[2]; // lat,long ; screen x,y
extern float p2a; // angle that player is facing
extern float p2at;  // angle of travel, angles are north of east;
extern float p2v; // speed
extern float p2av; // angular velocity
extern float p2rad; // player 2 saucer radius
extern int p2colc, p2colf; //color of center, color of forward angle
extern unsigned int p2shotsfired;

extern float muzzlespeed;
extern float shotexplrad;

//extern struct plrsaverestore[2]; 

//other globals;
extern int gridcol; //252;  //105;
extern int backproj; //flag for if the projected image is // viewed through from opposite side, like from under instead of above
extern int trajmath; //trajectory math method selector
extern float uf_p2p; // coefficient of friction between players, for transverse impulse in collisions
extern int curioswitch2;  // programmers probe on '|'

extern   int keyp1tl,keyp1f,keyp1tr,keyp1l,keyp1b,keyp1r,keyp1fire,keyp1det; //booleans for player keys down
extern   int keyp2tl,keyp2f,keyp2tr,keyp2l,keyp2b,keyp2r,keyp2fire,keyp2det;
extern   int keyenvintcom; // ascii character of latest environment interface command key

extern int p1turnl, p2turnl;
extern int p1turnr, p2turnr;

typedef struct
{
  float x;
  float y;
  float z;
} vector ;

#endif